package com.monitorabrasil.participacidadao.stores;

import com.monitorabrasil.participacidadao.actions.Action;
import com.monitorabrasil.participacidadao.actions.PoliticoActions;
import com.monitorabrasil.participacidadao.dispatcher.Dispatcher;
import com.parse.ParseObject;
import com.squareup.otto.Subscribe;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Geraldo on 13/08/2015.
 */
public class ProjetoStore extends Store{

    private static ProjetoStore instance;
    private String status;
    private String evento;
    private List<ParseObject> projetos;

    protected ProjetoStore(Dispatcher dispatcher) {
        super(dispatcher);
        projetos = new ArrayList<>();
    }

    public static ProjetoStore get(Dispatcher dispatcher) {
        if (instance == null) {
            instance = new ProjetoStore(dispatcher);
        }
        return instance;
    }

    public List<ParseObject> getProjetos(){
        return projetos;
    }


    @Override
    @Subscribe
    public void onAction(Action action) {
        status = "erro";
        this.evento = action.getType();

        switch (action.getType()) {
            case PoliticoActions.POLITICO_GET_ALL:
                projetos = ((List<ParseObject>) action.getData().get(PoliticoActions.KEY_TEXT));
                emitStoreChange();
                break;

        }
    }

    @Override
    StoreChangeEvent changeEvent() {
        UserStoreChangeEvent mUserStoreChangeEvent = new UserStoreChangeEvent();
        mUserStoreChangeEvent.status = this.status;
        mUserStoreChangeEvent.evento = this.evento;
        return mUserStoreChangeEvent;
    }


    public class UserStoreChangeEvent implements StoreChangeEvent {
        private String status;
        private String evento;

        public String getEvento() {
            return evento;
        }

        public String getStatus() {
            return status;
        }
    }
}
