package com.monitorabrasil.participacidadao.view;

import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.support.v4.app.FragmentTransaction;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;

import com.mikepenz.materialdrawer.Drawer;
import com.mikepenz.materialdrawer.DrawerBuilder;
import com.mikepenz.materialdrawer.accountswitcher.AccountHeader;
import com.mikepenz.materialdrawer.accountswitcher.AccountHeaderBuilder;
import com.mikepenz.materialdrawer.model.DividerDrawerItem;
import com.mikepenz.materialdrawer.model.PrimaryDrawerItem;
import com.mikepenz.materialdrawer.model.ProfileDrawerItem;
import com.mikepenz.materialdrawer.model.SecondaryDrawerItem;
import com.mikepenz.materialdrawer.model.interfaces.IDrawerItem;
import com.mikepenz.materialdrawer.model.interfaces.IProfile;
import com.monitorabrasil.participacidadao.R;
import com.monitorabrasil.participacidadao.application.MyApp;
import com.monitorabrasil.participacidadao.view.fragments.HomeFragment;
import com.nostra13.universalimageloader.core.assist.FailReason;
import com.nostra13.universalimageloader.core.listener.ImageLoadingListener;
import com.parse.ParseTwitterUtils;
import com.parse.ParseUser;


public class MainActivity extends AppCompatActivity implements HomeFragment.OnFragmentInteractionListener {



    private Toolbar mToolbar;
    private AccountHeader headerNavigationLeft;
    private Drawer navigationDrawerLeft;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        //FRAGMENT
        HomeFragment homeFragment = (HomeFragment) getSupportFragmentManager().findFragmentByTag("homeFrag");
        if(homeFragment == null) {
            homeFragment = homeFragment.newInstance();
            FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
            ft.replace(R.id.rl_fragment_container, homeFragment, "homeFrag");
            ft.commit();
        }

         // TOOLBAR
            mToolbar = (Toolbar) findViewById(R.id.tb_main);
            mToolbar.setTitle(getString(R.string.app_name));
            mToolbar.setSubtitle("Ouro Branco - MG");
            //mToolbar.setLogo(R.drawable.ic_launcher);
            setSupportActionBar(mToolbar);
        mToolbar.setTitleTextColor(getResources().getColor(R.color.md_white_1000));
        mToolbar.setSubtitleTextColor(getResources().getColor(R.color.md_white_1000));

            /*getSupportActionBar().setDisplayHomeAsUpEnabled(true);
            getSupportActionBar().setHomeButtonEnabled(false);*/


        headerNavigationLeft = new AccountHeaderBuilder()
                .withActivity(this)
                 .withHeaderBackground(R.drawable.rsz_ourobranco)
                .withOnAccountHeaderListener(new AccountHeader.OnAccountHeaderListener() {
                    @Override
                    public boolean onProfileChanged(View view, IProfile profile, boolean currentProfile) {
                        startActivity(new Intent(getApplicationContext(), LoginActivity.class));

                        return false;
                    }
                })
                .build();

        ParseUser currentUser = ParseUser.getCurrentUser();
        if (currentUser != null) {

            if(ParseTwitterUtils.getTwitter()!=null){
                String screenName = ParseTwitterUtils.getTwitter().getScreenName();
                MyApp.getInstance().getmImagemLoader().loadImage("https://twitter.com/" + screenName + "/profile_image?size=bigger", new ImageLoadingListener() {
                    @Override
                    public void onLoadingStarted(String imageUri, View view) {

                    }

                    @Override
                    public void onLoadingFailed(String imageUri, View view, FailReason failReason) {

                    }

                    @Override
                    public void onLoadingComplete(String imageUri, View view, Bitmap loadedImage) {
                        headerNavigationLeft.addProfiles(
                                new ProfileDrawerItem().withName(ParseTwitterUtils.getTwitter().getScreenName()).
                                        withEmail(ParseUser.getCurrentUser().getEmail()).
                                        withIcon(loadedImage)

                        );
                    }

                    @Override
                    public void onLoadingCancelled(String imageUri, View view) {

                    }
                });



                Uri uri =  Uri.parse("https://twitter.com/" + screenName + "/profile_image?size=bigger");

//                MyApp.getInstance().getmImagemLoader().lo.loadImageSync("https://twitter.com/" + screenName + "/profile_image?size=bigger");
//                headerNavigationLeft.getProfiles().get(0).setIcon(uri);

//                Uri uri =  Uri.parse("https://twitter.com/"+screenName+"/profile_image?size=bigger");



            }else{
                headerNavigationLeft.addProfiles(
                        new ProfileDrawerItem().withName(currentUser.get("nome").toString()).
                                withEmail(currentUser.getEmail())
                                .withIcon(getResources().getDrawable(R.drawable.person_1))
                );
            }



        } else {
            headerNavigationLeft.addProfiles(
                    new ProfileDrawerItem().withName("Faa seu cadastro"));
        }

        navigationDrawerLeft = new DrawerBuilder()
                .withActivity(this)
                .withToolbar(mToolbar)
                .withDisplayBelowToolbar(false)
                .withActionBarDrawerToggleAnimated(true)
                .withDrawerGravity(Gravity.START)
                .withSavedInstance(savedInstanceState)
                .withActionBarDrawerToggle(true)
                 .withAccountHeader(headerNavigationLeft)
                .addDrawerItems(
                        new PrimaryDrawerItem().withName("Home"),
                        new DividerDrawerItem(),
                        new PrimaryDrawerItem().withName("Vereadores"),
                        new SecondaryDrawerItem().withName("Indicaes"),
                        new SecondaryDrawerItem().withName("Cmara"),
                        new SecondaryDrawerItem().withName("Sobre")
                )
                .withOnDrawerItemClickListener(new Drawer.OnDrawerItemClickListener() {
                    @Override
                    public boolean onItemClick(AdapterView<?> parent, View view, int position, long id, IDrawerItem drawerItem) {
                        switch (position){
                            case 0:
                                HomeFragment homeFragment = (HomeFragment) getSupportFragmentManager().findFragmentByTag("homeFrag");
                                if(homeFragment == null) {
                                    homeFragment = homeFragment.newInstance();
                                    FragmentTransaction ft = getSupportFragmentManager().beginTransaction();
                                    ft.replace(R.id.rl_fragment_container, homeFragment, "homeFrag");
                                    ft.commit();
                                }
                                break;


                            case 2:
                                startActivity(new Intent(getApplicationContext(), PoliticosActivity.class));
                                break;

                            case 3:
                                startActivity(new Intent(getApplicationContext(),ProjetosActivity.class));
                                break;

                            case 4:
                                startActivity(new Intent(getApplicationContext(), CamaraActivity.class));
                                break;
                            case 5:
                                startActivity(new Intent(getApplicationContext(), SobreActivity.class));
                                break;

                        }
                        navigationDrawerLeft.closeDrawer();

                        return true;
                    }
                })
                .build();


    }




    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_sobre) {
            startActivity(new Intent(getApplicationContext(),SobreActivity.class));
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onBackPressed() {
        if(navigationDrawerLeft.isDrawerOpen()){
            navigationDrawerLeft.closeDrawer();
        }
        /*else if(fab.isOpened()){
            fab.close(true);
        }*/
        else{
            super.onBackPressed();
        }
    }


    @Override
    public void onFragmentInteraction(Uri uri) {

    }
}
