package com.monitorabrasil.participacidadao.view.adapters;

import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.monitorabrasil.participacidadao.R;
import com.monitorabrasil.participacidadao.view.interfaces.RecyclerViewOnClickListenerHack;
import com.parse.ParseObject;

import java.util.List;

/**
 * Created by geral_000 on 05/07/2015.
 */
public class ComentarioAdapter extends RecyclerView.Adapter<ComentarioAdapter.ViewHolder> {

    private List<ParseObject> mDataset;
    private RecyclerViewOnClickListenerHack mRecyclerViewOnClickListenerHack;

    // Provide a reference to the views for each data item
    // Complex data items may need more than one view per item, and
    // you provide access to all the views for a data item in a view holder
    public class ViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener{
        // each data item is just a string in this case
        public TextView txtUser;
        public TextView txtComentario;
        public ViewHolder(View v) {
            super(v);
            txtUser = (TextView) v.findViewById(R.id.txtUser);
            txtComentario = (TextView) v.findViewById(R.id.txtComentario);

            itemView.setOnClickListener(this);
        }

        @Override
        public void onClick(View v) {
            if(mRecyclerViewOnClickListenerHack != null){
                mRecyclerViewOnClickListenerHack.onClickListener(v, getPosition());
            }
        }
    }

    public ComentarioAdapter(List<ParseObject> myDataset) {
        mDataset = myDataset;
    }

    @Override
    public ComentarioAdapter.ViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        // create a new view
        View v = LayoutInflater.from(viewGroup.getContext())
                .inflate(R.layout.item_comentario, viewGroup, false);
        // set the view's size, margins, paddings and layout parameter
        ViewHolder vh = new ViewHolder(v);
        return vh;
    }
    public void setRecyclerViewOnClickListenerHack(RecyclerViewOnClickListenerHack r){
        mRecyclerViewOnClickListenerHack = r;
    }

    @Override
    public void onBindViewHolder(ComentarioAdapter.ViewHolder viewHolder, int i) {
        ParseObject  comentario = mDataset.get(i);
       // vereador.pinInBackground();
        viewHolder.txtUser.setText(comentario.get("nome").toString());
        viewHolder.txtComentario.setText(comentario.get("mensagem").toString());
    }

    @Override
    public int getItemCount() {
        return mDataset.size();
    }
}
