package com.monitorabrasil.participacidadao.view.dialogs;

import android.annotation.SuppressLint;
import android.app.Dialog;
import android.app.DialogFragment;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RatingBar;


import com.monitorabrasil.participacidadao.R;
import com.parse.ParseException;
import com.parse.ParseObject;
import com.parse.ParseQuery;
import com.parse.ParseUser;
import com.parse.SaveCallback;

@SuppressLint("ValidFragment")
public class DialogAvaliacao extends DialogFragment {

	int idUser;
	int idPolitico;
	private String titulo;
	private ParseObject mPolitico;
	private ParseObject mAvaliacao;

	private DialogInterface.OnDismissListener onDismissListener;

	private boolean jaVotou;



	public DialogAvaliacao(ParseObject politico, String titulo) {
		this.titulo=titulo;
		this.mPolitico = politico;
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		final View view = inflater.inflate(R.layout.dialog_avaliacao, container, false);

		final RatingBar rb = (RatingBar) view.findViewById(R.id.ratingBar1);

		jaVotou = false;

		// setar avaliacao feita
		ParseQuery<ParseObject> query = ParseQuery.getQuery("Avaliacao");
		query.fromLocalDatastore();
		try {
			query.whereEqualTo("politico", mPolitico);
			mAvaliacao = query.getFirst();
			if(mAvaliacao != null){
				jaVotou = true;
				rb.setRating((float)mAvaliacao.getDouble("avaliacao"));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		//rb.setRating(new UserDAO(getActivity()).buscaAvaliacaoSalva(idPolitico));

		Button btnCancelar = (Button) view.findViewById(R.id.cancel);
		btnCancelar.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				getDialog().dismiss();

			}
		});

		Button btnOk = (Button) view.findViewById(R.id.ok);
		btnOk.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(final View v) {
				if(ParseUser.getCurrentUser()!= null){
					double ultimaAvaliacao=0;
					//salva a avaliacao
					if(!jaVotou){
						mAvaliacao = new ParseObject("Avaliacao");
						mAvaliacao.put("politico",mPolitico);
						mAvaliacao.put("user", ParseUser.getCurrentUser());
					}else{
						//guardar a ultima valor da avaliacao anterior
						ultimaAvaliacao = mAvaliacao.getDouble("avaliacao");
					}

					mAvaliacao.put("avaliacao", rb.getRating());
					mAvaliacao.saveInBackground(new SaveCallback() {
						@Override
						public void done(ParseException e) {

						}
					});
					mAvaliacao.pinInBackground();
					try {
						mPolitico.fetchFromLocalDatastore();
					} catch (ParseException e) {
						e.printStackTrace();
					}
					int nrAvalicao = mPolitico.getInt("qtd_avaliacao");
					double media =  mPolitico.getDouble("avaliacao");
					double total = nrAvalicao*media;
					if(jaVotou){
						total = total - ultimaAvaliacao;
					}else{
						nrAvalicao++;
						mPolitico.increment("qtd_avaliacao");
					}

					mPolitico.put("avaliacao", (rb.getRating() + total) / nrAvalicao);

					mPolitico.saveInBackground();
					mPolitico.pinInBackground();
				}

				getDialog().dismiss();
			}
		});
		return view;
	}

	@Override
	public Dialog onCreateDialog(Bundle savedInstanceState) {

		Dialog dialog = super.onCreateDialog(savedInstanceState);
		// dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setTitle(titulo);

		// WindowManager.LayoutParams lp = new WindowManager.LayoutParams();
		// lp.copyFrom(dialog.getWindow().getAttributes());
		// lp.width = WindowManager.LayoutParams.MATCH_PARENT-20;
		// dialog.show();
		// dialog.getWindow().setAttributes(lp);

		return dialog;
	}



	public void setOnDismissListener(DialogInterface.OnDismissListener onDismissListener) {
		this.onDismissListener = onDismissListener;
	}

	@Override
	public void onDismiss(DialogInterface dialog) {
		super.onDismiss(dialog);
		if (onDismissListener != null) {
			onDismissListener.onDismiss(dialog);
		}
	}



}