package com.monitorabrasil.participacidadao.view.fragments;

import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.support.v7.widget.GridLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.monitorabrasil.participacidadao.R;
import com.monitorabrasil.participacidadao.view.adapters.TipoProjetoAdapter;
import com.monitorabrasil.participacidadao.view.interfaces.RecyclerViewOnClickListenerHack;
import com.parse.FindCallback;
import com.parse.ParseObject;
import com.parse.ParseQuery;

import java.util.List;

/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link EscolhaTipoProjeto.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link EscolhaTipoProjeto#newInstance} factory method to
 * create an instance of this fragment.
 */
public class EscolhaTipoProjeto extends Fragment implements RecyclerViewOnClickListenerHack {
    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";
    private RecyclerView mRecyclerView;
    private TipoProjetoAdapter mAdapter;

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    private OnFragmentInteractionListener mListener;

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment EscolhaTipoProjeto.
     */
    // TODO: Rename and change types and number of parameters
    public static EscolhaTipoProjeto newInstance(String param1, String param2) {
        EscolhaTipoProjeto fragment = new EscolhaTipoProjeto();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    public EscolhaTipoProjeto() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view =  inflater.inflate(R.layout.fragment_escolha_tipo_projeto, container, false);

        //tableview
        mRecyclerView = (RecyclerView) view.findViewById(R.id.rv_escolha_tipo);

        // use this setting to improve performance if you know that changes
        // in content do not change the layout size of the RecyclerView
        mRecyclerView.setHasFixedSize(true);

        GridLayoutManager llm = new GridLayoutManager(getActivity(),2,GridLayoutManager.VERTICAL, false);
        mRecyclerView.setLayoutManager(llm);

        //busca os tipos de projetos
        buscaTiposProjetos();

        return view;
    }

    private void buscaTiposProjetos() {
        ParseQuery<ParseObject> query = ParseQuery.getQuery("TipoProjeto");
        query.addAscendingOrder("nome");
        query.findInBackground(new FindCallback<ParseObject>() {
            @Override
            public void done(List<ParseObject> list, com.parse.ParseException e) {
                if (e == null) {
                    carregaList(list);
                } else {
                    Log.d("score", "Error: " + e.getMessage());
                }
            }


        });
    }

    private void carregaList(List<ParseObject> list) {
        mAdapter = new TipoProjetoAdapter(list,getActivity());
        mAdapter.setRecyclerViewOnClickListenerHack(this);
        mRecyclerView.setAdapter(mAdapter);
        //pb.setVisibility(View.INVISIBLE);
    }

    @Override
    public void onClickListener(View view, int position) {
         ListaProjetosFragment frag = (ListaProjetosFragment) getActivity().getSupportFragmentManager().findFragmentByTag("listaProjFrag");
        if(frag == null) {
            frag = ListaProjetosFragment.newInstance(mAdapter.getItem(position),null);
            FragmentTransaction ft = getActivity().getSupportFragmentManager().beginTransaction();
            ft.replace(R.id.rl_fragment_container, frag, "listaProjFrag");
            ft.addToBackStack(null);
            ft.commit();
        }

    }

    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }



    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p/>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        public void onFragmentInteraction(Uri uri);
    }

}
