package com.monitorabrasil.participacidadao.view.fragments;

import android.app.Activity;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;

import com.github.mikephil.charting.charts.BarChart;
import com.github.mikephil.charting.data.BarEntry;
import com.monitorabrasil.participacidadao.R;
import com.monitorabrasil.participacidadao.view.adapters.GastoAdapter;
import com.monitorabrasil.participacidadao.model.Grafico;
import com.parse.FindCallback;
import com.parse.ParseException;
import com.parse.ParseObject;
import com.parse.ParseQuery;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link GastosCamaraFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link GastosCamaraFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class GastosCamaraFragment extends Fragment {


    protected BarChart mChart;
    private View mView;
    private HashMap<String,HashMap<String,Float>> dataset = new HashMap<String,HashMap<String,Float>>();
    private HashMap<String,Float> valorTotal = new HashMap<String,Float>();
    ArrayList<String> xVals = new ArrayList<String>();
    ArrayList<BarEntry> yVals1 = new ArrayList<BarEntry>();
    private RecyclerView mRecyclerView;
    private GastoAdapter mAdapter;
    List<Grafico> myDataset=new ArrayList<Grafico>();
    List<String> tipos = new ArrayList<String>();
    int[] cores = new int[]{R.color.cor1, R.color.cor2,R.color.cor3, R.color.cor4,R.color.cor5, R.color.cor6,
            R.color.cor7, R.color.cor8,R.color.cor9, R.color.cor10};

    private ProgressBar pb;



    private OnFragmentInteractionListener mListener;

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment GastosCamaraFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static GastosCamaraFragment newInstance(String param1, String param2) {
        GastosCamaraFragment fragment = new GastosCamaraFragment();
        Bundle args = new Bundle();
//        args.putString(ARG_PARAM1, param1);
//        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    public GastosCamaraFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
//            mParam1 = getArguments().getString(ARG_PARAM1);
//            mParam2 = getArguments().getString(ARG_PARAM2);
        }
    }



    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view =inflater.inflate(R.layout.fragment_lista_projetos, container, false);
         pb = (ProgressBar) view.findViewById(R.id.progressBar);
//        pb.setVisibility(View.VISIBLE);
        mView=view;
//        mChart = (BarChart) view.findViewById(R.id.chart1);
//        mChart.setVisibility(View.GONE);
//        buildGraph();

        //tableview
        mRecyclerView = (RecyclerView) view.findViewById(R.id.my_recycler_view);

        // use this setting to improve performance if you know that changes
        // in content do not change the layout size of the RecyclerView
        mRecyclerView.setHasFixedSize(true);

        LinearLayoutManager llm = new LinearLayoutManager(getActivity());
        llm.setOrientation(LinearLayoutManager.VERTICAL);
        mRecyclerView.setLayoutManager(llm);
        buscaGastos();
        return  view;
    }

    private ParseObject buscaGastos() {

        ParseQuery<ParseObject> query = ParseQuery.getQuery("DespesaCamara");
        query.setLimit(200);
        //query.whereEqualTo("politico",politico);

        query.addAscendingOrder("mes_numero");
        query.findInBackground(new FindCallback<ParseObject>() {
            public void done(List<ParseObject> gastos, ParseException e) {

                Iterator<ParseObject> gastoIt = gastos.iterator();

                while (gastoIt.hasNext()) {

                    ParseObject g = gastoIt.next();
                    String mes = g.getString("mes");
                    Float novoValor = Float.valueOf(g.getString("valor"));

                    String tipo = g.getString("tipo");
                    if(!tipos.contains(tipo)){
                        tipos.add(tipo);
                    }
                    //verifica tipo
                    HashMap<String,Float> data = dataset.get(tipo);
                    if(data != null){
                        //verifica se tem o valor por mes
                        Float valorMesTipo = data.get(mes);
                        if(valorMesTipo != null){
                            valorMesTipo = valorMesTipo +novoValor;
                            data.remove(mes);
                            data.put(mes, valorMesTipo);
                        }else{
                            data.put(mes,novoValor);
                        }


                    }else{
                        data = new HashMap<String, Float>();
                        data.put(mes,novoValor);
                        dataset.put(tipo,data);
                    }


                    Float valor = valorTotal.get(mes);
                    if (valor != null) {
                        valor = valor + novoValor;
                        valorTotal.remove(mes);
                        valorTotal.put(mes, valor);
                    } else {
                        valorTotal.put(mes, novoValor);
                    }
                    if (!xVals.contains(mes)) {
                        xVals.add(mes);
                    }

                    //


                }
                for (int j = 0; j < xVals.size(); j++) {
                    Float val = valorTotal.get(xVals.get(j));
                    yVals1.add(new BarEntry(val, j));
                }
                Grafico grafico = new Grafico("Todos", yVals1, xVals, R.color.cor10);
                myDataset.add(grafico);

                //adicionar os outros graficos
                for(int i=0; i < tipos.size();i++ ){
                    HashMap<String,Float> temp = dataset.get(tipos.get(i));
                    ArrayList<String> x = new ArrayList<String>();
                    for ( int k=0; k < temp.size(); k++ ) {
                        x.add(k,"");
                    }
                    ArrayList<BarEntry> y = new ArrayList<BarEntry>();
                    for ( String mes : temp.keySet() ) {
                        if(!x.contains(mes)){
                            int pos = buscaPosicao(mes);
                            x.remove(pos);
                            x.add(pos, mes);
                        }
                        Float val = temp.get(mes);
                        y.add(new BarEntry(val, x.indexOf(mes)));
                    }



                    myDataset.add(new Grafico(tipos.get(i),y,x,cores[i]));
                }

                carregaList();
                pb.setVisibility(View.INVISIBLE);

                //   setData();

            }
        });


        return null;
    }

    private int buscaPosicao(String mes) {
        int ret=0;
        switch (mes){
            case "JAN":
                ret=0;
                break;
            case "FEV":
                ret=1;
                break;
            case "MAR":
                ret=2;
                break;
            case "ABR":
                ret=3;
                break;
            case "MAI":
                ret=4;
                break;
            case "JUN":
                ret=5;
                break;
            case "JUL":
                ret=6;
                break;
            case "AGO":
                ret=7;
                break;
            case "SET":
                ret=8;
                break;
            case "OUT":
                ret=9;
                break;
            case "NOV":
                ret=10;
                break;
            case "DEZ":
                ret=11;
                break;

        }
        return ret;
    }

    public void carregaList(){
        mAdapter = new GastoAdapter(myDataset);
//        mAdapter.setRecyclerViewOnClickListenerHack(this);
        mRecyclerView.setAdapter(mAdapter);
//        pb.setVisibility(View.INVISIBLE);
    }



    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
//        try {
//            mListener = (OnFragmentInteractionListener) activity;
//        } catch (ClassCastException e) {
//            throw new ClassCastException(activity.toString()
//                    + " must implement OnFragmentInteractionListener");
//        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p/>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        public void onFragmentInteraction(Uri uri);
    }

}
