package com.monitorabrasil.participacidadao.view.fragments;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.crashlytics.android.Crashlytics;
import com.github.mikephil.charting.animation.Easing;
import com.github.mikephil.charting.charts.BarChart;
import com.github.mikephil.charting.components.Legend;
import com.github.mikephil.charting.components.XAxis;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.data.BarData;
import com.github.mikephil.charting.data.BarDataSet;
import com.github.mikephil.charting.data.BarEntry;
import com.github.mikephil.charting.utils.ValueFormatter;
import com.monitorabrasil.participacidadao.view.PoliticoFichaActivity;
import com.monitorabrasil.participacidadao.R;
import com.monitorabrasil.participacidadao.view.adapters.PoliticoAdapter;
import com.monitorabrasil.participacidadao.application.MyApp;
import com.monitorabrasil.participacidadao.model.Grafico;
import com.monitorabrasil.participacidadao.view.interfaces.RecyclerViewOnClickListenerHack;
import com.monitorabrasil.participacidadao.model.util.MyValueFormatter;
import com.parse.FindCallback;
import com.parse.ParseException;
import com.parse.ParseObject;
import com.parse.ParseQuery;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link HomeFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link HomeFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class HomeFragment extends Fragment implements RecyclerViewOnClickListenerHack {


    private OnFragmentInteractionListener mListener;
    private RecyclerView mRecyclerView;
    private PoliticoAdapter mAdapter;
    private List<ParseObject> ob;
    private HashMap<String,Float> valorTotal = new HashMap<String,Float>();
    ArrayList<String> xVals = new ArrayList<String>();
    ArrayList<BarEntry> yVals1 = new ArrayList<BarEntry>();

    public BarChart mChart;

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     * @return A new instance of fragment HomeFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static HomeFragment newInstance() {
        HomeFragment fragment = new HomeFragment();
        Bundle args = new Bundle();

        fragment.setArguments(args);
        return fragment;
    }

    public HomeFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View  view = inflater.inflate(R.layout.fragment_home, container, false);
        //tableview
        mRecyclerView = (RecyclerView) view.findViewById(R.id.my_recycler_view);


        // use this setting to improve performance if you know that changes
        // in content do not change the layout size of the RecyclerView
        mRecyclerView.setHasFixedSize(true);

        LinearLayoutManager llm = new LinearLayoutManager(getActivity());
        llm.setOrientation(LinearLayoutManager.VERTICAL);
        mRecyclerView.setLayoutManager(llm);

        //buscar os vereadores
        buscaVereadores();

        //buscar o grafico de gastos
        mChart = (BarChart)view.findViewById(R.id.chart1);

        buscaGastos();

        FloatingActionButton fab = (FloatingActionButton) view.findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent sharingIntent = new Intent(android.content.Intent.ACTION_SEND);
                sharingIntent.setType("text/plain");
                String shareBody = "Recomendo o app Participa Cidado https://play.google.com/store/apps/details?id=com.monitorabrasil.monitoramunicipio";
                sharingIntent.putExtra(android.content.Intent.EXTRA_SUBJECT, "Participa Cidado");
                sharingIntent.putExtra(android.content.Intent.EXTRA_TEXT, shareBody);
                startActivity(Intent.createChooser(sharingIntent, "Compartilhar via"));

            }
        });


        return view;
    }

    private ParseObject buscaGastos() {

        ParseQuery<ParseObject> query = ParseQuery.getQuery("DespesaCamara");
        query.setLimit(200);
        //query.whereEqualTo("politico",politico);

        query.addAscendingOrder("mes_numero");
        query.findInBackground(new FindCallback<ParseObject>() {
            public void done(List<ParseObject> gastos, ParseException e) {
                if(null != gastos){
                    Iterator<ParseObject> gastoIt = gastos.iterator();

                    while (gastoIt.hasNext()) {

                        ParseObject g = gastoIt.next();
                        String mes = g.getString("mes");
                        Float novoValor = Float.valueOf(g.getString("valor"));
                        Float valor = valorTotal.get(mes);
                        if (valor != null) {
                            valor = valor + novoValor;
                            valorTotal.remove(mes);
                            valorTotal.put(mes, valor);
                        } else {
                            valorTotal.put(mes, novoValor);
                        }
                        if (!xVals.contains(mes)) {
                            xVals.add(mes);
                        }

                    }
                    for (int j = 0; j < xVals.size(); j++) {
                        Float val = valorTotal.get(xVals.get(j));
                        yVals1.add(new BarEntry(val, j));
                    }
                    Grafico grafico = new Grafico("Todos", yVals1, xVals, R.color.cor10);
                    buildGraph(grafico);
                }


            }
        });


        return null;
    }

    private void buildGraph(Grafico grafico) {

//        mChart.set

        mChart.setDrawBarShadow(false);
        mChart.setDrawValueAboveBar(true);

        mChart.setDescription("");

        // if more than 60 entries are displayed in the chart, no values will be
        // drawn
        mChart.setMaxVisibleValueCount(60);

        // scaling can now only be done on x- and y-axis separately
        mChart.setPinchZoom(false);

        // draw shadows for each bar that show the maximum value
        // mChart.setDrawBarShadow(true);

        // mChart.setDrawXLabels(false);

        mChart.setDrawGridBackground(false);
        // mChart.setDrawYLabels(false);

//        mTf = Typeface.createFromAsset(getAssets(), "OpenSans-Regular.ttf");

        XAxis xAxis = mChart.getXAxis();
        xAxis.setPosition(XAxis.XAxisPosition.BOTTOM);
//        xAxis.setTypeface(mTf);
        xAxis.setDrawGridLines(false);
        xAxis.setSpaceBetweenLabels(2);

        ValueFormatter custom = new MyValueFormatter();

        YAxis leftAxis = mChart.getAxisLeft();
//        leftAxis.setTypeface(mTf);
        leftAxis.setLabelCount(8,true);
        leftAxis.setValueFormatter(custom);
        leftAxis.setPosition(YAxis.YAxisLabelPosition.OUTSIDE_CHART);
        leftAxis.setSpaceTop(15f);

        mChart.getAxisRight().setEnabled(false);
        YAxis rightAxis = mChart.getAxisRight();
        rightAxis.setDrawGridLines(false);
//        rightAxis.setTypeface(mTf);
        rightAxis.setLabelCount(8,true);
        rightAxis.setValueFormatter(custom);
        rightAxis.setSpaceTop(15f);

        Legend l = mChart.getLegend();
        l.setPosition(Legend.LegendPosition.BELOW_CHART_LEFT);
        l.setForm(Legend.LegendForm.SQUARE);
        l.setFormSize(9f);
        l.setTextSize(11f);
        l.setXEntrySpace(4f);
        // l.setExtra(ColorTemplate.VORDIPLOM_COLORS, new String[] { "abc",
        // "def", "ghj", "ikl", "mno" });
        // l.setCustom(ColorTemplate.VORDIPLOM_COLORS, new String[] { "abc",
        // "def", "ghj", "ikl", "mno" });



        // setting data
//        mSeekBarY.setProgress(50);
//        mSeekBarX.setProgress(12);
//
//        mSeekBarY.setOnSeekBarChangeListener(this);
//        mSeekBarX.setOnSeekBarChangeListener(this);

        // mChart.setDrawLegend(false);


        //setdata

        setData(grafico);

        mChart.animateX(2500, Easing.EasingOption.EaseInOutQuart);
        mChart.notifyDataSetChanged();

    }

    private void setData(Grafico grafico) {



        BarDataSet set1 = new BarDataSet(grafico.getyAxis(), "Gastos Totais");
        set1.setBarSpacePercent(35f);

        ArrayList<BarDataSet> dataSets = new ArrayList<BarDataSet>();
        dataSets.add(set1);
        try{
            set1.setColor(MyApp.getInstance().getResources().getColor(grafico.getCor()));

            BarData data = new BarData(grafico.getxVals(), dataSets);
            // data.setValueFormatter(new MyValueFormatter());
            data.setValueTextSize(10f);
//        data.setValueTypeface(mTf);
            mChart.setVisibility(View.VISIBLE);
            mChart.setData(data);



        }catch (Exception e){
            Crashlytics.log("GastosCamaraFragment " + e.toString());
        }

    }

    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    //busca objetos
    public void buscaVereadores(){
        ParseQuery<ParseObject> query = ParseQuery.getQuery("Politico");
        query.addDescendingOrder("avaliacao");
        //query.whereEqualTo("playerName", "Dan Stemkoski");
        query.findInBackground(new FindCallback<ParseObject>() {
            @Override
            public void done(List<ParseObject> list, com.parse.ParseException e) {
                if (e == null) {
                    ob = list;
                    carregaList(list);
                } else {
                    Log.d("score", "Error: " + e.getMessage());
                }
            }


        });
    }

    public void carregaList(List<ParseObject> list){
        mAdapter = new PoliticoAdapter(list);
        mAdapter.setRecyclerViewOnClickListenerHack(this);
        mRecyclerView.setAdapter(mAdapter);
        //pb.setVisibility(View.INVISIBLE);
    }

    @Override
    public void onClickListener(View view, int position) {
        Intent intent = new Intent(getActivity(),PoliticoFichaActivity.class);
        intent.putExtra("politico", ob.get(position).getObjectId());
        startActivity(intent);

    }

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        try {
            mListener = (OnFragmentInteractionListener) activity;
        } catch (ClassCastException e) {
            throw new ClassCastException(activity.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p/>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        public void onFragmentInteraction(Uri uri);
    }

}
