package com.monitorabrasil.participacidadao.view.fragments;


import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;

import com.monitorabrasil.participacidadao.R;
import com.monitorabrasil.participacidadao.actions.ActionsCreator;
import com.monitorabrasil.participacidadao.dispatcher.Dispatcher;
import com.monitorabrasil.participacidadao.stores.PoliticoStore;
import com.monitorabrasil.participacidadao.stores.ProjetoStore;
import com.monitorabrasil.participacidadao.view.adapters.ProjetoAdapter;
import com.monitorabrasil.participacidadao.view.interfaces.RecyclerViewOnClickListenerHack;
import com.parse.ParseObject;
import com.parse.ParseQuery;
import com.squareup.otto.Bus;
import com.squareup.otto.Subscribe;

import java.util.List;

/**
 * A simple {@link Fragment} subclass.
 */
public class ListaProjetosFragment extends Fragment implements RecyclerViewOnClickListenerHack {

    private RecyclerView mRecyclerView;
    private ProjetoAdapter mAdapter;
    private List<ParseObject> ob;
    private ProgressBar pb;
    private static final String TIPO_PROJETO = "tipoProjeto";
    private static final String ID_POLITICO = "idPolitico";
    private String tipoProjeto;
    private String idPolitico;

    private Dispatcher dispatcher;
    private ActionsCreator actionsCreator;
    private ProjetoStore projetoStore;


    public static ListaProjetosFragment newInstance(String tipoProjeto, String idPolitico) {
        ListaProjetosFragment fragment = new ListaProjetosFragment();
        Bundle args = new Bundle();
        args.putString(TIPO_PROJETO, tipoProjeto);
        args.putString(ID_POLITICO, idPolitico);
        fragment.setArguments(args);
        return fragment;
    }
    public ListaProjetosFragment(){

    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            tipoProjeto = getArguments().getString(TIPO_PROJETO);
            idPolitico = getArguments().getString(ID_POLITICO);
        }
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view =  inflater.inflate(R.layout.fragment_lista_projetos, container, false);
      //  View view =  inflater.inflate(R.layout.fragment_escolha_tipo_projeto, container, false);

        initDependencies();
        setupView(view);

        actionsCreator.getAllProjetos(idPolitico, tipoProjeto);

        return view;
    }

    private void initDependencies() {
        dispatcher = Dispatcher.get(new Bus());
        actionsCreator = ActionsCreator.get(dispatcher);
        projetoStore = ProjetoStore.get(dispatcher);
    }


    private void setupView(View view) {
        pb.setVisibility(View.VISIBLE);


        pb = (ProgressBar) view.findViewById(R.id.progressBar);


        //tableview
        mRecyclerView = (RecyclerView) view.findViewById(R.id.my_recycler_view);

        // use this setting to improve performance if you know that changes
        // in content do not change the layout size of the RecyclerView
        mRecyclerView.setHasFixedSize(true);

        LinearLayoutManager llm = new LinearLayoutManager(getActivity());
        llm.setOrientation(LinearLayoutManager.VERTICAL);
        mRecyclerView.setLayoutManager(llm);
        mAdapter = new ProjetoAdapter(actionsCreator);
        mRecyclerView.setAdapter(mAdapter);
        mAdapter.setRecyclerViewOnClickListenerHack(this);
    }

    private void updateUI() {
        mAdapter.setItems(projetoStore.getProjetos());
        pb.setVisibility(View.INVISIBLE);
    }

    private ParseObject buscaPolitico(String  id) {

        ParseQuery<ParseObject> query = ParseQuery.getQuery("Politico");
        query.fromLocalDatastore();
        try {
            return query.get(id);
        } catch (com.parse.ParseException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * Atualiza a UI depois de uma action
     * @param event
     */
    @Subscribe
    public void onTodoStoreChange(PoliticoStore.UserStoreChangeEvent event) {
        updateUI();
    }

    @Override
    public void onClickListener(View view, int position) {


//        PoliticoFragment frag = new PoliticoFragment();
//        Bundle bundle = new Bundle();
//        try {
//            ob.get(position).pin();
//        } catch (ParseException e) {
//            e.printStackTrace();
//        }
//        bundle.putString("politico", ob.get(position).getObjectId());
//        frag.setArguments(bundle);
//        FragmentTransaction ft = getActivity().getSupportFragmentManager().beginTransaction();
//        ft.replace(R.id.rl_fragment_container, frag, "politicoFrag");
//        ft.addToBackStack(null);
//        ft.commit();
    }

}
