package com.monitorabrasil.participacidadao.view.fragments;

import android.content.DialogInterface;
import android.graphics.PorterDuff;
import android.graphics.drawable.LayerDrawable;
import android.os.Build;
import android.os.Bundle;
import android.support.design.widget.Snackbar;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;

import com.crashlytics.android.answers.Answers;
import com.crashlytics.android.answers.ContentViewEvent;
import com.monitorabrasil.participacidadao.R;
import com.monitorabrasil.participacidadao.application.MyApp;
import com.monitorabrasil.participacidadao.view.dialogs.DialogAvaliacao;
import com.parse.ParseException;
import com.parse.ParseObject;
import com.parse.ParseQuery;
import com.parse.ParseUser;

/**
 * Created by geral_000 on 20/06/2015.
 */
public class PoliticoFichaFragment  extends Fragment {


    private ParseObject politico;
    private View mView;
    private RatingBar mRatingBar;
    private Button btnAvaliar;


    public View onCreateView(LayoutInflater inflater,
                             ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_politico_detalhe, container, false);



        mView=view;
        mRatingBar = (RatingBar)view.findViewById(R.id.ratingBar);





        Bundle bundle = getArguments();
        politico = buscaPolitico(bundle.getString("politico")) ;

        Answers.getInstance().logContentView(new ContentViewEvent()
                .putContentName("PoliticoFichaFragment")
                .putContentType("Fragment")
        .putCustomAttribute("vereador",politico.getString("nome")));


        mRatingBar.setRating((float) politico.getDouble("avaliacao"));

        if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP){
            LayerDrawable stars = (LayerDrawable) mRatingBar.getProgressDrawable();
            stars.getDrawable(2).setColorFilter(getResources().getColor(R.color.colorAccent), PorterDuff.Mode.SRC_ATOP);
            stars.getDrawable(1).setColorFilter(getResources().getColor(R.color.colorAccent), PorterDuff.Mode.SRC_ATOP);
            stars.getDrawable(0).setColorFilter(getResources().getColor(R.color.coloLink), PorterDuff.Mode.SRC_ATOP);
        }


        //btnAvaliar
        btnAvaliar = (Button) view.findViewById(R.id.btnAvalie);
        btnAvaliar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(final View v) {
                if(ParseUser.getCurrentUser() != null){
                    DialogAvaliacao avaliacao =new DialogAvaliacao(politico, "Avalie");
                    avaliacao.setOnDismissListener(new DialogInterface.OnDismissListener() {
                        @Override
                        public void onDismiss(DialogInterface dialog) {
                            //atualizar a avaliacao
                            try {
                                politico.fetchFromLocalDatastore();
                                mRatingBar.setRating((float) politico.getDouble("avaliacao"));
                                Snackbar.make(v, "Avaliao salva.", Snackbar.LENGTH_LONG)
                                        .setAction("Action", null).show();
                            } catch (ParseException e) {
                                e.printStackTrace();
                            }

                        }
                    });
                    avaliacao.show(getActivity().getFragmentManager(), "dialogAvaliar");
                }else{
                    Snackbar.make(v, " necessrio logar para avaliar.", Snackbar.LENGTH_LONG)
                            .setAction("Action", null).show();
                }

            }
        });

        //foto
        ImageView foto = (ImageView)view.findViewById(R.id.foto);
        MyApp.getInstance().getmImagemLoader().displayImage(MyApp.URL_FOTO+politico.get("cpf")+".jpg",foto);

        //nome
        TextView txtNome = (TextView) view.findViewById(R.id.txtNome);
        txtNome.setText(politico.get("nome").toString());

        //telefone
        TextView telefone = (TextView) view.findViewById(R.id.txtTelefone);
        telefone.setText(politico.get("telefone").toString());
        //telefone
        TextView txtPartido = (TextView) view.findViewById(R.id.txtPartido);
        txtPartido.setText(politico.get("partido").toString());
        //email
        TextView email = (TextView) view.findViewById(R.id.email);
        email.setText(politico.get("email").toString());
        //facebook
        TextView facebook = (TextView) view.findViewById(R.id.facebook);
        facebook.setText(politico.get("facebook").toString());
        //gastos
        TextView gastos = (TextView) view.findViewById(R.id.gastos);
        gastos.setText(politico.get("gasto_campanha").toString().replace(",","").replace(".",","));
        //bens declarados
        TextView bens = (TextView) view.findViewById(R.id.bens);
        bens.setText(politico.get("bens_declarados").toString().replace(",", "").replace(".",","));

        return view;
    }

    @Override
    public void onResume() {
        Log.e("DEBUG", "onResume of HomeFragment");
        super.onResume();
    }


    private ParseObject buscaPolitico(String  id) {

        ParseQuery<ParseObject> query = ParseQuery.getQuery("Politico");
        query.fromLocalDatastore();
        try {
            return query.get(id);
        } catch (com.parse.ParseException e) {
            e.printStackTrace();
        }
        return null;
    }
}
